/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     OtBbNtCu@VA                      */
/* o[W   Ver.1.00                                                    */
/* Date         2012.04.27                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */
#include "glcd_lib_sirial.h"            /* ̨tرِײ    */
#include "font_8x8.h"                   /* 8~8dot tHg             */

/*======================================*/
/* V{`                         */
/*======================================*/
#define CMD     glcd_cmd1               /* R}hݒ肷ϐ       */
#define DATA    glcd_cmd2               /* f[^ݒ肷ϐ         */

#define  RST_1  (CMD |=  GLCD_RST)
#define  RST_0  (CMD &= ~GLCD_RST)
#define  CS2_1  (CMD |=  GLCD_CS2)
#define  CS2_0  (CMD &= ~GLCD_CS2)
#define  CS1_1  (CMD |=  GLCD_CS1)
#define  CS1_0  (CMD &= ~GLCD_CS1)
#define  E_1    (CMD |=  GLCD_E  )
#define  E_0    (CMD &= ~GLCD_E  )
#define  RS_1   (CMD |=  GLCD_RS )
#define  RS_0   (CMD &= ~GLCD_RS )

#define glcd_left()  { CS2_0; CS1_1; set_glcd_sirial_data(); }
#define glcd_right() { CS1_0; CS2_1; set_glcd_sirial_data(); }

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/
static int glcd_x;                      /* ̨t X\ʒu    */
static int glcd_y;                      /* ̨t Yʒuʒu    */
static int glcd_k;                      /* 0:J^Ji@1:Ђ炪Ȃŕ\ */

static unsigned char glcd_cmd1;         /* VAőR}h       */
static unsigned char glcd_cmd2;         /* VAőf[^         */

/************************************************************************/
/* VAŃf[^M                                                 */
/* @ Mf[^                                                    */
/* ߂l 0:MőMł 1:Mf[^Zbg                   */
/************************************************************************/
static int put_uart0( char r )
{
    if(ti_u0c1 == 1) {                  /* Mf[^ȂH             */
        u0tbl = r;
        return 1;
    } else {
        /* ɑM(̃f[^͑MɏI) */
        return 0;
    }
}

/************************************************************************/
/* OtBbNtɃVAŃf[^M                               */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void set_glcd_sirial_data( void )
{
    while( !put_uart0( glcd_cmd1 ) );   /* փf[^o           */
    while( !put_uart0( glcd_cmd2 ) );   /* DB7`0փf[^o           */
    while( !txept_u0c0 );               /* o͂I܂ő҂         */
    HC595_LCK = 1;                      /* 74HC595f[^o        */
    HC595_LCK = 0;
}

/************************************************************************/
/* OtBbNtɃR}h𑗂                                     */
/* @ R}h                                                  */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void glcd_cmd(unsigned char c)
{
    RS_0;                             /* Mf[^̓R}h           */
    DATA = c;
    E_1;
    set_glcd_sirial_data();
    E_0;
    set_glcd_sirial_data();
}

/************************************************************************/
/* OtBbNtɃf[^𑗂                                       */
/* @ f[^                                                    */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void glcd_data( unsigned char c )
{
    RS_1;                               /* Mf[^̓f[^           */
    DATA = c;
    E_1;
    set_glcd_sirial_data();
    E_0;
    set_glcd_sirial_data();
}

/************************************************************************/
/* OtBbNt̕\ʒuw                                 */
/* @ x:0`127 y:0`7(\hbǵAy*8̈ʒu)                      */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_position( unsigned char x, unsigned char y )
{
    if( x < 64 ) {
        glcd_left();                    /* 64Ȃ獶               */
    } else {
        glcd_right();                   /* 64ȏȂE               */
    }

    glcd_x = x;
    glcd_y = y;

    glcd_cmd( 0x40 | (x & 0x3f) );      /* ̈ʒuݒ                 */
    glcd_cmd( 0xb8 | (y & 0x07) );      /* c̈ʒuݒ                 */
}

/************************************************************************/
/* OtBbNt̕\NA                                       */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_clear( void )
{
    unsigned char x, y;

    for( y=0; y<8; y++ ) {
        for( x=0; x<128; x++ ) {
            glcd_position( x, y );
            glcd_data( 0x00 );
        }
    }
}

/************************************************************************/
/* OtBbNt                                             */
/* @ long \鐔l, int (1`10)                            */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_sirial_init( void )
{
    /* UART0̐ݒ */
    mstuart = 0;                        /* UART0Lɂ            */
#if TXD0 == 1
    p14sel2 = 0;                        /* P1_4 = TXD0[qɂ        */
    p14sel1 = 0;
    p14sel0 = 1;
#endif
#if TXD0 == 2
    p42sel1 = 1;                        /* P4_2 = TXD0[qɂ        */
    p42sel0 = 0;
#endif
#if TXD0 == 3
    p46sel2 = 0;                        /* P4_6 = TXD0[qɂ        */
    p46sel1 = 1;
    p46sel0 = 0;
#endif

    p16sel1 = 0;                        /* P1_6 = CLK0[qɂ        */
    p16sel0 = 1;

    u0mr  = 0x11;                       /* ۯرI/OӰ        */
    u0c0  = 0x80;                       /* MSB̧ U0BRGĿ:f1     */
    u0brg = 0;                          /* f1     /(16*(u0brg+1)) =     */
                                        /* 20*10^6/(16*(0+1))=1250000pbs*/
    te_u0c1 = 1;                        /* Mrbg:M      */

    /* OtBbNt */
    RST_1;                              /* RST1ɂăf[^M       */
    set_glcd_sirial_data();

    RST_0;                              /* RST0ɂăf[^M       */
    set_glcd_sirial_data();

    RST_1;                              /* RST1ɂăf[^M       */
    set_glcd_sirial_data();

    glcd_left();
    glcd_cmd( 0x3f );                   /* Display ON                   */

    glcd_right();
    glcd_cmd( 0x3f );                   /* Display ON                   */

    glcd_clear();
}

/************************************************************************/
/* OtBbNt 1oCgM̃J^JiAЂ炪ȂI             */
/* @ 0:ϊȂ(J^Ji\) 1:J^JiЂ炪Ȃɕϊĕ\   */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_kana( int flag )
{
    if( flag ) {
        glcd_k = 1;
    } else {
        glcd_k = 0;
    }
}

/************************************************************************/
/* OtBbNt 1C\(1~8dot)                                */
/* @ \f[^(1bytes=1~8dot)                                  */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_data( unsigned char data )
{
    // 1C(1~8dot)\
    glcd_position( glcd_x, glcd_y );
    glcd_data( data );
    glcd_x++;
    if( glcd_x >= 128 ) {               /* Xʒȕ`FbN          */
        glcd_x  = 0;
        glcd_y += 1;
        if( glcd_y >= 8 ) glcd_y = 0;   /* Yʒȕ`FbN          */
    }
}

/************************************************************************/
/* OtBbNt 1oCgM                                         */
/* @ char data LCDW[ւ̑Mf[^                         */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_ch( int data )
{
    int i;

    // Ђ炪ȕ\`FbN
    if( glcd_k ) {
        if( data >= 0xa6 && data <= 0xbf ) {
            data -= 0x20;
        } else if( data >= 0xc0 && data <= 0xfd ) {
            data += 0x20;
        }
    }

    data -= 0x20;
    data <<= 3;

    // 1\
    for( i=0; i<8; i++ ) {
        glcd_position( glcd_x, glcd_y );
        glcd_data( font[data++] );
        glcd_x++;
        if( glcd_x >= 128 ) {
            glcd_x  = 0;
            glcd_y += 1;
            if( glcd_y >= 8 ) glcd_y = 0;
            break;
        }
    }
}

/************************************************************************/
/* OtBbNtɐl(10i)\                                 */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_num( long value, int keta )
{
    long temp = 0;
    int i = keta-1;

    while( (i--) != 0 ) {
        temp += value % 10;
        value /= 10;
        temp <<= 4;
    }
    temp += (value % 10);

    do {
        glcd_put_ch( (temp & 0xf) + '0' ); /* 1\                 */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* OtBbNtɐl(16i)\                                 */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_hex( unsigned long value, int keta )
{
    long temp = 0;
    int i = keta-1;
    char c;

    while( (i--) != 0 ) {
        temp += (value & 0x0f);
        value >>= 4;
        temp <<= 4;
    }
    temp += (value & 0xf);

    do {
        c = temp & 0x0f;
        c += (c < 10) ? '0' : ('a'-10);
        glcd_put_ch( c );               /* 1\                    */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* OtBbNt \                                          */
/* @ char *str : ̐擪|C^                              */
/* ߂l Ȃ                                                          */
/************************************************************************/
void glcd_put_str( const char *str )
{
    while(*str != 0) {
        glcd_put_ch( *str );             /* 1M                   */
        str++;
    }
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/

/*
o
Ver.1.00 2012.04.27 쐬
*/